--[[
				 Honor Kills Counter
		written by Torrid - Black Dragonflight/Dentarg servers
]]

HKC_CFG = {
	chatMessages = false,
	onClickMsg = false;
}

HKC_KILLSTODAY = {};
HKC_KILLSLIFETIME = {};

HKC_LASTKILL = "";
HKC_PLAYER = nil;
HKC_VARSLOADED = false;
HKC_PENDINGUPDATE = false;
HKC_LASTWIN_TIMESTAMP = 0;
HKC_MAX_HISTORY = 100;

HKCLastEstimated = 0;
HKCInBattleground = false;
HKCMap = "";
HKCEnterTime = 0;
HKCSelected = 1;
HKCFrameText = {};

function HKC_OnLoad()
	SlashCmdList["HKC"] = HKCCmdLine;
	SLASH_HKC1 = "/hkc"; 

	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("CHAT_MSG_COMBAT_HONOR_GAIN");
--	this:RegisterEvent("UNIT_NAME_UPDATE");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("UPDATE_MOUSEOVER_UNIT");
	this:RegisterEvent("UPDATE_BATTLEFIELD_SCORE");

	if (DEFAULT_CHAT_FRAME) then
		DEFAULT_CHAT_FRAME:AddMessage(HKC_LOGINMSG);
	end
end

function HKCResetToday(forcereset)
	local hk, dk, contribution, rank;
	local moreThanTwoDays = false;

	-- check date, if it's been more than two days, reset
	local d = date("*t");
	local dateStamp = time(d);		-- today's date in seconds (one big number)

	-- if no date in player data, then he is new to v2.  Rely on yesterday's values
	if ( HKC_CFG[HKC_PLAYER].dateStamp ) then
		if ( dateStamp > (HKC_CFG[HKC_PLAYER].dateStamp + 172800) ) then	-- 172800 = two days
			moreThanTwoDays = true;
		end
	end

	HKC_CFG[HKC_PLAYER].dateStamp = dateStamp;

	-- Yesterday's values
	hk, contribution = GetPVPYesterdayStats();

	-- if yesterday's values differ from when last logged in, wipe kills for today
	if (	moreThanTwoDays or
		HKC_CFG[HKC_PLAYER].yesterdayHK ~= hk or
		HKC_CFG[HKC_PLAYER].yesterdayCP ~= contribution or
		forcereset
	) then
		-- new day
		if ( HKC_CFG[HKC_PLAYER].estCP.HKCtoday > 0 ) then
			HKC_AddHistory( "|c00ffffff"..date().."|r: "..string.format(HKC_RESETHISTORY, HKC_CFG[HKC_PLAYER].estCP.HKCtoday) );
		end

		HKC_CFG[HKC_PLAYER].yesterdayHK = hk;
		HKC_CFG[HKC_PLAYER].yesterdayCP = contribution;

		HKC_KILLSTODAY[HKC_PLAYER] = {};

		-- wipe estinated CP for today
		HKC_CFG[HKC_PLAYER].estCP.blizzToday = 0;
		HKC_CFG[HKC_PLAYER].estCP.HKCtoday = 0;

		DEFAULT_CHAT_FRAME:AddMessage(HKC_RESET, 1, 0, 0);
	end
end

function HKCLogin()

	HKC_PLAYER = UnitName("player").." "..GetCVar("realmName");

	-- new player?
	if (not HKC_KILLSLIFETIME[HKC_PLAYER]) then
		HKC_CFG[HKC_PLAYER] = { yesterdayHK = 0, yesterdayCP = 0};
		HKC_KILLSLIFETIME[HKC_PLAYER] = {};
		HKC_KILLSTODAY[HKC_PLAYER] = {};
	end

	-- delete now unused data when new version installed
	if (HKC_CFG[HKC_PLAYER].LWDK) then
		HKC_CFG[HKC_PLAYER].LWDK = nil;
		HKC_CFG[HKC_PLAYER].YHK = nil;
		HKC_CFG[HKC_PLAYER].LWrank = nil;
		HKC_CFG[HKC_PLAYER].YC = nil;
		HKC_CFG[HKC_PLAYER].LWHK = nil;
		HKC_CFG[HKC_PLAYER].LWC = nil;
		HKC_CFG[HKC_PLAYER].CPthisweek = nil;
		HKC_CFG[HKC_PLAYER].ESTCP = nil;
		HKC_CFG[HKC_PLAYER].YDK = nil;
		if (HKC_STANDINGS) then
			HKC_STANDINGS = nil;
		end
		if (HKC_WBLSTANDINGS) then
			HKC_WBLSTANDINGS = nil;
		end
		if (HKCHonorBonusHistory) then
			HKCHonorBonusHistory = nil;
		end
		if (HKCBGHonorHistory) then
			HKCBGHonorHistory = nil;
		end
	end

	if (not HKC_CFG[HKC_PLAYER].estCP) then
		HKC_CFG[HKC_PLAYER].estCP = {
			blizzToday = 0,
			HKCtoday = 0,
		};
	end

	if (not HKC_CFG[HKC_PLAYER].HonorBonusHistory) then
		HKC_CFG[HKC_PLAYER].HonorBonusHistory = {};
	end

	if (not HKC_CFG[HKC_PLAYER].BGHonorHistory) then
		HKC_CFG[HKC_PLAYER].BGHonorHistory = {};
	end

	-- check for new day, reset if it is
	HKCResetToday();

end

function HKCGetPlayerName()
	local pname;

	pname = UnitName("player");
	if (pname and pname ~= UNKNOWNOBJECT and pname ~= UKNOWNBEING and pname ~= UNKNOWNOBJECT) then
		HKCLogin();
	end
end

function HKC_EstimateCP(ecp)
	if (HKC_KILLSTODAY[HKC_PLAYER][HKC_LASTKILL] > 10) then
		return 0
	elseif (HKC_KILLSTODAY[HKC_PLAYER][HKC_LASTKILL] == 1) then
		return ecp
	else
		return ecp - ( (HKC_KILLSTODAY[HKC_PLAYER][HKC_LASTKILL] - 1) / 10 * ecp );
--		ecp = math.ceil(ecp - ( (HKC_KILLSTODAY[HKC_PLAYER][HKC_LASTKILL] - 1) / 10 * ecp ));
--		return ecp
	end
end

function HKC_AddHistory(s)
	table.insert(HKC_CFG[HKC_PLAYER].HonorBonusHistory, s);

	local i, n;

	n = #HKC_CFG[HKC_PLAYER].HonorBonusHistory;
	if ( n > HKC_MAX_HISTORY ) then
		for i = 1, (n - HKC_MAX_HISTORY) do
			table.remove(HKC_CFG[HKC_PLAYER].HonorBonusHistory, 1);
		end
	end
end

function HKC_BonusHistoryOnExit()
	-- call this after player just left a BG

	gained = math.floor(HKC_CFG[HKC_PLAYER].estCP.HKCtoday - HKCLastEstimated);
	elapsed = math.floor( (time() - HKCEnterTime) / 60 );

	if (gained < 0) then
		gained = "?";
	end

	if (HKC_CFG.chatMessages) then
		DEFAULT_CHAT_FRAME:AddMessage( string.format(HKC_ENDBG, HKCMap, elapsed, gained) );
	end

	if (HKCMap == "Eastern Kingdoms") then
		return
	end

	-- Honor bonus history
	HKC_AddHistory( string.format(HKC_EXIT_HISTORY1, date(), HKCMap) );
	if ( HKC_Winner ) then
		HKC_AddHistory( string.format(getglobal("VICTORY_TEXT"..HKC_Winner)..";  "..HKC_EXIT_HISTORY2, elapsed, gained) );
	else
		HKC_AddHistory( string.format(HKC_EXIT_HISTORY2, elapsed, gained) );
	end

	-- BG Honor History
	if (elapsed > 2 and gained ~= "?") then		-- ignore BGs less than 3 mins
							-- or day roll overs
		if (not HKC_CFG[HKC_PLAYER].BGHonorHistory[HKCMap]) then
			HKC_CFG[HKC_PLAYER].BGHonorHistory[HKCMap] = {};
		end

		table.insert(HKC_CFG[HKC_PLAYER].BGHonorHistory[HKCMap], { honor = gained, time = elapsed } );
		if (table.getn(HKC_CFG[HKC_PLAYER].BGHonorHistory[HKCMap]) > 10) then
			table.remove(HKC_CFG[HKC_PLAYER].BGHonorHistory[HKCMap], 1);
		end
	end

	-- win loss record
	if ( not HKC_CFG[HKC_PLAYER].winLossRecord ) then
		HKC_CFG[HKC_PLAYER].winLossRecord = {};
	end
	if ( not HKC_CFG[HKC_PLAYER].winLossRecord[HKCMap] ) then
		HKC_CFG[HKC_PLAYER].winLossRecord[HKCMap] = { wins = 0, losses = 0 };
	end

	if ( HKC_Winner ) then
		if ( HKC_Winner == 0 ) then
			-- Horde won

			if ( UnitFactionGroup("player") == "Horde" ) then
				HKC_CFG[HKC_PLAYER].winLossRecord[HKCMap].wins = HKC_CFG[HKC_PLAYER].winLossRecord[HKCMap].wins + 1;
			else
				HKC_CFG[HKC_PLAYER].winLossRecord[HKCMap].losses = HKC_CFG[HKC_PLAYER].winLossRecord[HKCMap].losses + 1;
			end
		end
		if ( HKC_Winner == 1 ) then
			-- Alliance won

			if ( UnitFactionGroup("player") == "Horde" ) then
				HKC_CFG[HKC_PLAYER].winLossRecord[HKCMap].losses = HKC_CFG[HKC_PLAYER].winLossRecord[HKCMap].losses + 1;
			else
				HKC_CFG[HKC_PLAYER].winLossRecord[HKCMap].wins = HKC_CFG[HKC_PLAYER].winLossRecord[HKCMap].wins + 1;
			end
		end
	end

	HKCInBattleground = false;
end

function HKC_OnEvent(event)
	if ( event == "UPDATE_MOUSEOVER_UNIT" ) then
		if ( UnitExists("mouseover") and HKC_KILLSTODAY[HKC_PLAYER][UnitName("mouseover")] ) then
			-- GameTooltipTextRight3:SetText("("..HKC_KILLSTODAY[HKC_PLAYER][UnitName("target")].." kills today)");
			-- GameTooltipTextRight3:Show();
			if (GameTooltipTextLeft3:GetText() == "PvP") then
				GameTooltipTextLeft3:SetText("PvP ("..HKC_KILLSTODAY[HKC_PLAYER][UnitName("mouseover")]..HKC_KILLSTODAYTEXT..")");
			end
		end

	elseif ( event == "PLAYER_TARGET_CHANGED" and HKC_CFG.onClickMsg ) then
		if (	UnitExists("target")
			and UnitIsPlayer("target")
			and UnitIsEnemy("target", "player")
			and UnitIsPVP("target")
			and not UnitIsTrivial("target")
		) then
			if (HKC_KILLSTODAY[HKC_PLAYER][UnitName("target")]) then
				UIErrorsFrame:AddMessage(HKC_KILLSTODAY[HKC_PLAYER][UnitName("target")]..HKC_KILLSTODAYTEXT, 1.0, 1.0, 1.0, 1.0, 1);
			else
				UIErrorsFrame:AddMessage(HKC_NEVERKILLED, 1.0, 1.0, 1.0, 1.0, 1);
			end
		end

	elseif (event == "CHAT_MSG_COMBAT_HONOR_GAIN") then
		local rank, ecp, HKCest;

		_, _, HKC_LASTKILL, rank, ecp = string.find(arg1, HKC_HONORGAIN1);

		-- if not PK
		if (not HKC_LASTKILL) then

			-- bonus honor?
			_, _, HKC_LASTKILL = string.find(arg1, HKC_HONORGAIN2);
			if (HKC_LASTKILL) then
				HKC_CFG[HKC_PLAYER].estCP.HKCtoday = HKC_CFG[HKC_PLAYER].estCP.HKCtoday + tonumber(HKC_LASTKILL);
				HKC_CFG[HKC_PLAYER].estCP.blizzToday = HKC_CFG[HKC_PLAYER].estCP.blizzToday + tonumber(HKC_LASTKILL);

				HKC_AddHistory( "|c00ffffff"..date().."|r: +"..HKC_LASTKILL );

				-- update frame if visible
				if ( HKCFrame:IsVisible() ) then
					HKCFrame_Update();
				end

				return
			end

			-- DK?
			_, _, HKC_LASTKILL = string.find(arg1, HKC_DISHONOR);
			if (HKC_CFG.chatMessages and HKC_LASTKILL) then
				DEFAULT_CHAT_FRAME:AddMessage(HKC_DISHONORWARNING..HKC_LASTKILL..")", 1, 0, 0);
			elseif (HKC_CFG.chatMessages) then
				-- unknown msg
				DEFAULT_CHAT_FRAME:AddMessage(HKC_ERRORMSG..arg1.."'");
			end

			return
		end

		if (not HKC_KILLSLIFETIME[HKC_PLAYER][HKC_LASTKILL]) then
			-- first ever kill of this person
			HKC_KILLSLIFETIME[HKC_PLAYER][HKC_LASTKILL] = 0;
		end
		if (not HKC_KILLSTODAY[HKC_PLAYER][HKC_LASTKILL]) then
			-- first kill today
			HKC_KILLSTODAY[HKC_PLAYER][HKC_LASTKILL] = 0;
		end
		HKC_KILLSTODAY[HKC_PLAYER][HKC_LASTKILL] = HKC_KILLSTODAY[HKC_PLAYER][HKC_LASTKILL] + 1;
		HKC_KILLSLIFETIME[HKC_PLAYER][HKC_LASTKILL] = HKC_KILLSLIFETIME[HKC_PLAYER][HKC_LASTKILL] + 1;

		if (ecp) then
			HKCest = HKC_EstimateCP(ecp);

			HKC_CFG[HKC_PLAYER].estCP.blizzToday = HKC_CFG[HKC_PLAYER].estCP.blizzToday + ecp;
			HKC_CFG[HKC_PLAYER].estCP.HKCtoday = HKC_CFG[HKC_PLAYER].estCP.HKCtoday + HKCest;

			-- update frame if visible
			if ( HKCFrame:IsVisible() ) then
				HKCFrame_Update();
			end
		end

		if (HKC_CFG.chatMessages) then
			-- convert to string to remove ".0" if this float is an int value, because it's ugly
			HKCest = tostring(HKCest);
			DEFAULT_CHAT_FRAME:AddMessage( string.format(HKC_KILLMSG, HKC_LASTKILL, HKC_KILLSTODAY[HKC_PLAYER][HKC_LASTKILL], rank, HKCest) );
		end

	elseif (event == "PLAYER_ENTERING_WORLD") then
		if (HKC_VARSLOADED) then
			HKCGetPlayerName();
		else
			HKC_PENDINGUPDATE = true;
		end

		-- is player entering or leaving a BG?
		local i, id, map, elapsed, gained;
		for i=1, MAX_BATTLEFIELD_QUEUES do

			_, map, id = GetBattlefieldStatus(i);
			if (id ~= 0) then

				-- Player entering a BG

				if ( HKCInBattleground and map ~= HKCMap ) then
					-- player switched battlegrounds
					HKC_BonusHistoryOnExit();
				end

				HKCInBattleground = true;
				HKCMap = map;
				HKCLastEstimated = HKC_CFG[HKC_PLAYER].estCP.HKCtoday;
				HKCEnterTime = time();

				-- bonus history on BG entrance; remove earliest entry if more than 30
				HKC_AddHistory( string.format(HKC_ENTERED, date(), map) );

				return
			end
		end

		if (HKCInBattleground) then
			HKC_BonusHistoryOnExit();
		end

	elseif ( event == "UPDATE_BATTLEFIELD_SCORE" ) then
		HKC_Winner = GetBattlefieldWinner(); 


--	elseif (event == "UNIT_NAME_UPDATE" and arg1 == "player" and not HKC_PLAYER) then
--		HKCGetPlayerName();

	elseif ( event == "VARIABLES_LOADED" ) then
		HKC_VARSLOADED = true;
		if (HKC_PENDINGUPDATE) then
			HKCGetPlayerName();
		end
	end
end

function HKCZeroed()
	local name, kills;

	DEFAULT_CHAT_FRAME:AddMessage(HKC_NOHONOR, 1, 1, 0);

	for name, kills in pairs(HKC_KILLSTODAY[HKC_PLAYER]) do
		if (kills > 10) then
			DEFAULT_CHAT_FRAME:AddMessage(name.." ("..kills..")");
		end
	end
end

function HKCLookup(target)
	local char;

	-- force to lowercase then upper the 1st letter
	target = string.lower(target);
	char = string.sub(target, 1, 1);
	target = string.sub(target, 2);
	target = string.upper(char)..target;
	
	if (not HKC_KILLSLIFETIME[HKC_PLAYER][target]) then
		DEFAULT_CHAT_FRAME:AddMessage("0", 1, 1, 0);
		return
	end

	if (HKC_KILLSTODAY[HKC_PLAYER][target]) then
		DEFAULT_CHAT_FRAME:AddMessage(target.." "..HKC_KILLSTODAYTEXT..":"..HKC_KILLSTODAY[HKC_PLAYER][target], 1, 1, 0);
	else
		DEFAULT_CHAT_FRAME:AddMessage(target.." "..HKC_NEVERKILLED, 1, 1, 0);
	end

	DEFAULT_CHAT_FRAME:AddMessage( string.format(HKC_LIFETIMEKILLSMSG, target, HKC_KILLSLIFETIME[HKC_PLAYER][target]) , 1, 1, 0);
end

function HKCCmdLine(param)
	local arg1;
	local arg2;
	_, _, arg1, arg2 = string.find(param, "(%a+)%s+(.+)");
	if (not arg1) then
		arg1 = param;
	end

	if (arg1 == "lookup") then
		if (not arg2 and UnitExists("target")) then
			arg2 = UnitName("target");
		end
		if (arg2) then
			HKCLookup(arg2);
		end

	elseif (arg1 == "honor") then
		DEFAULT_CHAT_FRAME:AddMessage( HKC_HKCTODAYEST.." |c00ffff00"..HKC_CFG[HKC_PLAYER].estCP.blizzToday.."|r" );
		DEFAULT_CHAT_FRAME:AddMessage( HKC_BEFOREDIMINISHING.." |c00ffff00"..math.floor(HKC_CFG[HKC_PLAYER].estCP.HKCtoday).."|r" );
		-- if in a BG, show honor gained so far
		if (HKCInBattleground) then
			DEFAULT_CHAT_FRAME:AddMessage( HKC_FROMBG.." |c00ffff00"..math.floor(HKC_CFG[HKC_PLAYER].estCP.HKCtoday - HKCLastEstimated).."|r" );
		end

	elseif (arg1 == "zeroed") then
		HKCZeroed();

	elseif (arg1 == "forcereset") then
		if (arg2 == "today") then
			HKCResetToday(true);
		else
			DEFAULT_CHAT_FRAME:AddMessage(HKC_FORCERESET_SYNTAX, 1, 1, 0);
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage(HKC_HELP0, 1, 1, 0);
		DEFAULT_CHAT_FRAME:AddMessage(HKC_HELP1);
		DEFAULT_CHAT_FRAME:AddMessage(HKC_HELP2);
		DEFAULT_CHAT_FRAME:AddMessage(HKC_HELP3);
		DEFAULT_CHAT_FRAME:AddMessage(HKC_HELP4);
	end
end

function HKCFrameBGStats()

	HKCFrameText = {};

	-- BG avgs
	local bg, honorArr, avgHonor, avgTime, bgSession, dataPoints;

	for bg, honorArr in pairs(HKC_CFG[HKC_PLAYER].BGHonorHistory) do
		avgHonor = 0;
		avgTime = 0;

		dataPoints = table.getn(honorArr);

		for _, bgSession in pairs(honorArr) do
			avgHonor = avgHonor + bgSession.honor;
			avgTime = avgTime + bgSession.time;
		end

		avgHonor = math.floor(avgHonor / dataPoints);
		avgTime = math.floor(avgTime / dataPoints);

		table.insert(HKCFrameText, "|c00ffffff"..bg.."|r ("..HKC_LAST.." "..dataPoints..")");
		table.insert(HKCFrameText, HKC_AVGHONOR.." |c0000ffff"..avgHonor.."|r");
		table.insert(HKCFrameText, HKC_AVGTIME.." |c0000ffff"..avgTime.."|rm");
		table.insert(HKCFrameText, HKC_AVGHONORHOUR.." |c0000ffff"..math.floor((avgHonor / avgTime) * 60).."|r");

		if ( HKC_CFG[HKC_PLAYER].winLossRecord and HKC_CFG[HKC_PLAYER].winLossRecord[bg] ) then
			table.insert(HKCFrameText, HKC_WINLOSS.." |c0033ffcc"..HKC_CFG[HKC_PLAYER].winLossRecord[bg].wins.."|r/|c0033cccc"..HKC_CFG[HKC_PLAYER].winLossRecord[bg].losses.."|r");
		end

		table.insert(HKCFrameText, "");
	end

end

function HKCFrameHistory()
	local v;

	HKCFrameText = {};
	for _, v in ipairs(HKC_CFG[HKC_PLAYER].HonorBonusHistory) do
		table.insert(HKCFrameText, v);
	end
end

function HKCFrameTop(targetarr)
	local name, kills, count, lastkills, rank, victim, i;
	local top10 = {};
	local targetarr;
	local output = "";

	HKCFrameText = {};

	-- people killed today
	i = 0;
	for _ in pairs(HKC_KILLSTODAY[HKC_PLAYER]) do
		i = i + 1;
	end
	table.insert(HKCFrameText, string.format(HKC_PEOPLEKILLEDTODAY, i) );

	-- people killed lifetime
	i = 0;
	for _ in pairs(HKC_KILLSLIFETIME[HKC_PLAYER]) do
		i = i + 1;
	end
	table.insert(HKCFrameText, string.format(HKC_PEOPLEKILLEDLIFETIME, i) );

	-- number of people who no longer give contribution for today
	i = 0;
	for _, kills in pairs(HKC_KILLSTODAY[HKC_PLAYER]) do
		if (kills > 10) then
			i = i + 1;
		end
	end
	table.insert(HKCFrameText, string.format(HKC_SUMNOHONOR, i) );
	table.insert(HKCFrameText, "");

	for i = 1, 2 do
		if ( i == 1 ) then
			table.insert(HKCFrameText, "|c00ffffff"..HKC_TOP10TODAY.."|r");
			targetarr = HKC_KILLSTODAY[HKC_PLAYER];
		else
			table.insert(HKCFrameText, "|c00ffffff"..HKC_TOP10TOTAL.."|r");
			targetarr = HKC_KILLSLIFETIME[HKC_PLAYER];
		end
	
		for name, kills in pairs(targetarr) do
			table.insert(top10, {name = name, kills = kills});
		end

		table.sort(top10, 
			function(a, b)
				return a.kills > b.kills;
			end
		);

		count = 0;
		lastkills = 0;

		-- iterate every person killed
		for rank, victim in pairs(top10) do

			count = count + 1;

			-- lastkills is needed in case of a tie
			if (lastkills ~= victim.kills) then
				-- no tie

				if (lastkills > 0) then
					-- output player(s) and kill num
					table.insert( HKCFrameText, output.." ("..lastkills..")" );
					output = "";
				end
				lastkills = victim.kills;

				-- reached 10+ players
				-- this doesn't get seen in the case of a tie
				if (count > 10) then
					break;
				end
			else
				-- tie

				if ( #output > 35 ) then
					table.insert( HKCFrameText, output..", " );
					output = "";
				else
					output = output..", "
				end
			end

			output = output..victim.name;
		end

		table.insert( HKCFrameText, "" );
	end
end

function HKCFrameConfig()
	HKCFrameText = {};

	HKCChatMessagesCheckButton:Show()
	HKCOnClickMsgCheckButton:Show();

end

function HKCFrameDropDown_OnShow()
	UIDropDownMenu_Initialize( this, HKCFrameDropDown_Initialize );
	UIDropDownMenu_SetWidth( 100, HKCFrameDropDown );
	UIDropDownMenu_SetSelectedID( HKCFrameDropDown, HKCSelected );
	HKCFrameDropDown_OnClick();
end

function HKCFrameDropDown_Initialize()
	local k, v, info;

	for k, v in ipairs(HKC_DROPDOWN_LABELS) do
		UIDropDownMenu_AddButton( {
			text = v,
			value = k,
			func = HKCFrameDropDown_OnClick,
		} );
	end
end

function HKCFrameDropDown_OnClick()
	local value;

	HKCChatMessagesCheckButton:Hide()
	HKCOnClickMsgCheckButton:Hide();

	UIDropDownMenu_SetSelectedID( HKCFrameDropDown, this.value );
	value = UIDropDownMenu_GetSelectedID( HKCFrameDropDown );

	if ( value ) then
		HKCSelected = value;
	end

	if ( HKCSelected == 2 ) then
		HKCFrameHistory();
		HKCFrame_Update();	-- needed to get the scroll bar slider to end up at the bottom every time
		if ( #HKCFrameText == 100 ) then
			HKCScrollFrameScrollBar:SetValue(936);
		end
	elseif ( HKCSelected == 3 ) then
		HKCFrameTop();
	elseif ( HKCSelected == 4 ) then
		HKCFrameConfig();
	else
		HKCFrameBGStats();
	end
	HKCFrame_Update();
end

function HKCFrame_Update()
	local offset = FauxScrollFrame_GetOffset(HKCScrollFrame);
	local items = #HKCFrameText;
	local i;


	HKCFrameBlizHonorPoints:SetText( HKC_CFG[HKC_PLAYER].estCP.blizzToday );
	HKCFrameEstHonorPoints:SetText( math.floor(HKC_CFG[HKC_PLAYER].estCP.HKCtoday) );

	-- if in a BG, show honor gained so far
	if (HKCInBattleground) then
		local gained = math.floor(HKC_CFG[HKC_PLAYER].estCP.HKCtoday - HKCLastEstimated);
		HKCFrameHonorBGLabel:Show();
		HKCFrameBGHonorPoints:Show();
		HKCFrameBGHonorPoints:SetText(gained);
	else
		HKCFrameHonorBGLabel:Hide();
		HKCFrameBGHonorPoints:Hide();
	end

	for i = 1, 22 do
		if ( HKCFrameText[i + offset] ) then
			getglobal("HKCFrameBody"..i.."Text"):SetText( HKCFrameText[i + offset] );
		else
			getglobal("HKCFrameBody"..i.."Text"):SetText("");
		end

	end

	if ( items <= 22 ) then
		HKCScrollFrame:Hide();
	else
		HKCScrollFrame:Show();
	end

--[[
	frame,
	numItems,
	numToDisplay,
	valueStep,
	button,
	smallWidth,
	bigWidth,
	highlightFrame,
	smallHighlightWidth,
	bigHighlightWidth
	FauxScrollFrame_Update(	BattlefieldListScrollFrame,
				numBattlefields,
				BATTLEFIELD_ZONES_DISPLAYED,
				BATTLEFIELD_ZONES_HEIGHT,
				"BattlefieldZone",
				293, 315);
]]
	FauxScrollFrame_Update(HKCScrollFrame, items, 22, 12 );
end